﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.ScrollAxis;
using Syncfusion.UI.Xaml.TreeGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SfTreeGrid_MVVM
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.treeGrid.SelectionController = new GridSelectionControllerExt(treeGrid);
        }

      
    }

    public class GridSelectionControllerExt : TreeGridRowSelectionController
    {
        SfTreeGrid sfTreeGrid;
        public GridSelectionControllerExt(SfTreeGrid treeGrid)
         : base(treeGrid)
        {
            sfTreeGrid = treeGrid;
        }
        protected override void ProcessKeyDown(KeyEventArgs args)
        {
            base.ProcessKeyDown(args);
            if (CurrentCellManager.CurrentCell.TreeGridColumn is TreeGridTemplateColumn)
            {
                CurrentCellManager.CurrentCell.Renderer.SetFocus(true);
            }
        }

        public override void HandlePointerOperations(GridPointerEventArgs args, RowColumnIndex rowColumnIndex)
        {
            base.HandlePointerOperations(args, rowColumnIndex);
            if (args.Operation == PointerOperation.Move)
            {
                if (sfTreeGrid.Columns[rowColumnIndex.ColumnIndex] is TreeGridTemplateColumn)
                {
                        this.sfTreeGrid.SelectionController.MoveCurrentCell(rowColumnIndex, false);
                        CurrentCellManager.CurrentCell.Renderer.SetFocus(true);
                }
            }
        }

    }

}

